#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;
ll gcd(ll a, ll b) {
    return b ? gcd(b, a % b) : a;
}
int len = 300;

int main() {
    ios::sync_with_stdio(0);
    int n, k; cin >> n >> k;
    vector<ll> a(n);
    for (auto &x : a) cin >> x;
    vector<int> b(n / len  + 1);
    for (int i = 0; i < n; i++) {
        b[i / len] = gcd(b[i / len], a[i]);
    }
    int bs = b.size();
    vector<vector<int>> dp(bs + 1, vector<int> (bs  + 1));
    for (int i = 0; i < bs; i++)
        for (int j = 0; j < bs; j++) {
            dp[i][j] = gcd(b[i], b[j]);
        }

    auto get = [&] (int l, int r) {
            int id1 = (l + len - 1) / len;
            int id2 = r / len - 1;
            ll res = 0;
            if (min(id1, id2) >= 0 && max(id1, id2) < bs)
                res = dp[id1][id2];
        for (int i = l; i < r && i % len != 0; i++)
            res = gcd(res, a[i]);
        for (int i = max(l, r - r % len); i != r; i++)
            res = gcd(res, a[i]);

        return res;
    };
    ll ans = 1;
    ll last = 0;
    for (int i = 4; i + k <= n; i++) {
        ll cur = get(i, i + k);
        ans = max(ans, get(i, i + k));
    }
    cout << ans << endl;
    cin >> ans;
}