#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

long long gcd(long long a, long long b)
{
    if (b != 0) return gcd(b, a%b);
    else return a;
}

int main()
{
    int n, k;
    cin >> n >> k;

    auto a = vector<long long> (n);

    for (int i = 0; i < n; ++i) cin >> a[i];

    long long c = 1;

    for (int i = 0; i + k <= n; ++i)
    {
        int j = i + 1;
        long long g = gcd(a[i], a[j]);

        for (; j < i + k; ++j)
        {
            g = gcd(g, a[j]);
            if (g < c) break;
        }

        if (j == i + k && g > c) c = g;
    }

    cout << c;
}
