#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <algorithm>

using namespace std;

int32_t main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(), cout.tie(0);

    int n, k;
    cin >> n >> k;
    vector<int> v;
    int a;
    for (int i = 0; i < n; i++) {
        cin >> a;
        v.push_back(a);
    }
    int pas = (int)sqrt(n) + 1;
    vector<int> sq(pas);
    for (int i = 0; i < pas; i++) {
        int res = v[i * pas];
        for (int j = i * pas; j < (i + 1) * pas; j++) {
            res = __gcd(res, v[j]);
        }
        sq[i] = res;
    }
    int maxi = 0;
    for (int i = 0; i <= n - k; i++) {
        int res = v[i];
        for (int j = i; j < i + k; j++) {
            if (j % pas == 0 && j + pas - 1 < i + k) {
                res = __gcd(res, sq[j / pas]);
                j = j + pas - 1;
            } else {
                res = __gcd(res, v[j]);
            }
        }
        maxi = max(maxi, res);
    }
    cout << maxi;

    return 0;
}
