#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

#define p_r 2 * i + 2
#define p_l 2 * i + 1
#define M (r + l) / 2

long long arr[500000], t[2000000];
int n;

long long gcd(long long a, long long b)
{
	if (a == 0)
		return b;
	if (b == 0)
		return a;
	return gcd(b, a % b);
}

void build(int l = 0, int r = n, int i = 0)
{
	if (r - l == 1)
		t[i] = arr[l];
	else
	{
		build(l, M, p_l);
		build(M, r, p_r);
		t[i] = gcd(t[p_l], t[p_r]);
	}
}

long long q(int a_l, int a_r, int l = 0, int r = n, int i = 0)
{
	if (a_l >= r || a_r <= l)
		return 0;
	if (a_r >= r && a_l <= l)
		return t[i];
	return gcd(q(a_l, a_r, l, M, p_l),
	q(a_l, a_r, M, r, p_r));

}

int main()
{
	int k;
	cin >> n >> k;
	for (int i = 0; i < n; i++)
	{
		cin >> arr[i];
	}
	long long mmax = 0;
	build();
	for (int i = 0; i < n - k + 1; i++)
		mmax = max(mmax, q(i, i + k) );
	cout << mmax;
	//system("pause");
	return 0;
}