#include <iostream>
#include <algorithm>
#include <cstdio>
#include <vector>

using namespace std;

vector<int> t(2000001);
vector<int> a(500001);

int gecd(int a, int b){
    return b==0 ? a : gecd(b, a%b);
}

void build(int v, int tl, int tr){
    if(tl==tr) t[v] = a[tl];
    else {
        int tm = (tl+tr)/2;
        build(v*2, tl, tm);
        build(v*2+1, tm+1, tr);
        t[v] = gecd(t[v*2], t[v*2+1]);
    }
}

int gcd(int v, int tl, int tr, int l, int r){
    if(l>r)
        return 0;
    if(l==tl&&r==tr)
        return t[v];
    int tm = (tr+tl)/2;
    return gecd(gcd(v*2, tl, tm, l, min(r, tm)), gcd(v*2+1, tm+1, tr, max(l, tm+1), r));
}

int main(){
    int n, k, maxi=0, t;
    scanf("%d %d", &n, &k);
    for(int i=0; i<n; i++){
        cin >> a[i];
    }
    build(1, 0, n-1);
    for(int i=0; i+k-1<n; i++){
        t = gcd(1, 0, n-1, i, i+k-1);
        if(t>maxi) maxi = t;
    }
    printf("%d", maxi);
}
