
import java.util.*;
import java.io.*;

public class Main {
    FastScanner in;
    PrintWriter out;

    public void solve() throws IOException {
        int w = in.nextInt(),
                l = in.nextInt(),
                h = in.nextInt();
        if (Math.min(l, w) / h >= 2 && Math.max(l, w) / Math.min(l, w) <= 2) {
            out.println("good");
        } else {
            out.println("bad");
        }
    }

    public void run() {
        try {
            in = new FastScanner(System.in);
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    class FastScanner {
        BufferedReader br;
        StringTokenizer st;

        FastScanner(InputStream in) {
            br = new BufferedReader(new InputStreamReader(in));
        }

        String next() {
            while (st == null || !st.hasMoreTokens()) {
                try {
                    st = new StringTokenizer(br.readLine());
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            return st.nextToken();
        }

        int nextInt() {
            return Integer.parseInt(next());
        }
    }

    public static void main(String[] arg) {
        new Main().run();
    }
}