#include <iostream>
#include <set>
#include <algorithm>
#include <queue>
#include <vector>
using namespace std;

#define ll long long
#define vii vector<int>
#define pii pair<int, int>
#define ld long double
#define s second
#define f first
#define mp make_pair

ll gcd(ll a, ll b)
{
    if(b == 0)
        return a;
    else
        return gcd(b, a % b);
}

int main()
{
    ll n, k;
    cin >> n >> k;
    vector<ll> a(n);
    for(int i = 0; i < n; i++)
        cin >> a[i];

    vector<vector<ll> > dp(n, vector<ll>(2));

    for(int i = 0; i < n; i++)
        dp[i][1] = a[i];

    int cur = 1;
    ll len;
    for(len = 2; len <= k; len *= 2)
    {
        cur++;
        cur %= 2;
        for(ll x = 0; x <= n - k; x++)
        {
            if(cur == 0)
                dp[x][0] = gcd(dp[x][1], dp[x + len / 2][1]);
            else
                dp[x][1] = gcd(dp[x][0], dp[x + len / 2][0]);
        }
    }
    if(len != k)
    {
        for(int i = 0; i < n; i++)
        {
            if(dp[i][cur] == 0)
                break;
            for(int j = i + len; j < n; j++)
            {
                dp[i][cur] = gcd(dp[i][cur], a[j]);
            }
        }
    }


    ll answ = 0;
    for(int i = 0; i <= n - k; i++)
        answ = max(answ, dp[i][cur]);
    cout << answ << endl;
    return 0;
}
