#include <iostream>
#include <algorithm>
#include <sstream>
#include <vector>
#include <math.h>
#include <deque>
#include <string>

using namespace std;
#define li long long int
#define vec vector <li>
#define rep(n) for(li i = 0; i < n; i++)
#define pub push_back
#define sortv(myobject) sort(myobject.begin(), myobject.end())
#define sh(some) cout << some << endl

bool contains(string o, char d)
{
	for (li i = 0; i < o.size(); i++)
	{
		if (o[i] == d)
			return true;
	}
	return false;
}
vec contains(vec j, li o)
{
    vec u;
	rep(j.size())
	{
		if (j[i] == o)
			u.pub(i);
	}
	return u;
}
li cont(vec j, li o)
{
    vec u;
	rep(j.size())
	{
		if (j[i] == o)
			return i;
	}
	return -1;
}
li cont(vec j, li from, li o)
{
    vec u;
	for(li i = from; i < j.size(); i++)
	{
		if (j[i] == o)
			return i;
	}
	return -1;
}
string cut(string u, li st, li end)
{
	string r;
	while (st++ < end)
		r += u[st];
	return r;
}
bool isPrime (int num)
{
    if (num <=1)
        return false;
    else if (num == 2)
        return true;
    else if (num % 2 == 0)
        return false;
    else
    {
        bool prime = true;
        int divisor = 3;
        double num_d = static_cast<double>(num);
        int upperLimit = static_cast<int>(sqrt(num_d) +1);

        while (divisor <= upperLimit)
        {
            if (num % divisor == 0)
                prime = false;
            divisor +=2;
        }
        return prime;
    }
}
int gcd(int a, int b)
{
    for (;;)
    {
        if (a == 0) return b;
        b %= a;
        if (b == 0) return a;
        a %= b;
    }
}

int lcm(int a, int b)
{
    int temp = gcd(a, b);

    return temp ? (a / temp * b) : 0;
}
int scm(int a, int b, int c)
{
    return lcm(lcm(a, b), c);
}

int main()
{
    li n, d, k;
    cin >> n >> d >> k;
    li c = 0;
    deque <li> xs;
    deque <li> ys;
	xs.push_back(0);
	ys.push_back(0);
    li x = 0;
    li y = 0;

    while(c < n)
    {
        for(li i = 0; i < d; i++) {
            x++;
            c++;
            if(c > n)
                break;
            xs.push_back(x);
            ys.push_back(y);
        }
        for(li i = 0; i < d; i++) {
            y++;
            c++;
            if(c > n)
                break;
            xs.push_back(x);
            ys.push_back(y);
        }
        d *= k;
        for(li i = 0; i < d; i++) {
            x--;
            c++;
            if(c > n)
                break;
            xs.push_back(x);
            ys.push_back(y);
        }
        for(li i = 0; i < d; i++) {
            y--;
            c++;
            if(c > n)
                break;
            xs.push_back(x);
            ys.push_back(y);
        }
        d *= k;
    }
	li x_top = 0;
	li x_bottom = 0;
	li y_top = 0;
	li y_bottom = 0;
    for(li i = 1; i < xs.size(); i++) {
		li x = xs[i];
		li y = ys[i];
		
        x_top = max(x, x_top);
		x_bottom = min(x, x_bottom);
		y_top = max(y, y_top);
		y_bottom = min(y, y_bottom);
	}
	
	li w = x_top - x_bottom + 1;
	li h = y_top - y_bottom + 1;
	cout << w << " " << h << endl;
	
	string * img = new string[h];
	string blank;
	for(li i = 0; i < w; i++)
		blank += '.';
	for(li i = 0; i < h; i++) {
		img[i] = blank;
	}
	
	for(li i = 0; i < xs.size(); i++) {
		li x = xs[i] - x_bottom;
		li y = y_top - ys[i];
		img[y][x] = '*';
	}
	
	for(li i = 0; i < h; i++) {
		cout << img[i] << endl;
	}
	//system("pause");
	return 0;
}
