#pragma GCC optimize("Ofast,no-stack-protector,unroll-loops,fast-math")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4.1,sse4.2,popcnt,tune=native")
#pragma GCC target("avx,avx2")

#include <bits/stdc++.h>
typedef long long ll;
typedef long double ld;

using namespace std;

ll gcd(ll a, ll b){
    while (a * b != 0){
        if (a >= b){
            a %= b;
        } else {
            b %= a;
        }
    }
    return a + b;
}

ll n, k;
ll a[500000];
ll t[2000000];

ll build(ll v, ll l, ll r){
    if (l == r){
        t[v] = a[l];
        return t[v];
    }
    ll m = (l + r) / 2;
    t[v] = gcd(build(v * 2, l, m), build(v * 2 + 1, m + 1, r));
    return t[v];
}

ll get(ll v, ll l, ll r, ll tl, ll tr){
    if(l >= tr && r <= tr){
        return t[v];
    }
    if (tr < l || tl > r){
        return -1;
    }
    if (l == r){
        return a[l];
    }
    ll m = (l + r) / 2;
    ll x = get(v * 2, l, m, tl, tr);
    ll y = get(v * 2 + 1, m + 1, r, tl, tr);
    if (x == -1){
        return y;
    } else {
        if (y == -1){
            return x;
        } else {
            return gcd(x, y);
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n >> k;
    for(ll i = 0; i < n; ++i){
        cin >> a[i];
    }
    build(1, 0, n - 1);
    ll ans = 1;
    for(ll i = 0; i < n - k + 1; ++i){
        ans = max(ans, get(1, 0, n - 1, i, i + k - 1));
    }
    cout << ans << endl;
    return 0;
}