import java.util.*
import kotlin.math.max
import kotlin.math.min

object Potato {

    @JvmStatic
    fun main(args: Array<String>) {
        val table = TreeSet<Pair<Int, Int>> { a, b -> if (a.second == b.second) b.first.compareTo(a.first) else a.second.compareTo(b.second) }

        var n = readLine()!!.toInt() + 1
        val d = readLine()!!.toInt()
        val k = readLine()!!.toInt()
        var rotation = 0
        var step = d
        var untilRotation = step + 1
        var x = 0
        var y = 0
        var maxX = 0
        var minX = 0
        var maxY = 0
        var minY = 0
        while (n > 0) {
            when (rotation) {
                0 -> x++
                1 -> y++
                2 -> x--
                3 -> y--
            }
            untilRotation--
            if (untilRotation <= 0) {
                rotation++
                rotation %= 4
                if (rotation % 2 == 0) step *= k
                untilRotation = step
            }
            n--
            table += Pair(x, y)

            minX = min(minX, x)
            maxX = max(maxX, x)
            minY = min(minY, y)
            maxY = max(maxY, y)
        }
        var lastY = maxY
        var lastX = minX - 1
        val width = maxX - minX + 1
        val height = maxY - minY + 1
        println("$width $height")
        for ((x, y) in table.descendingIterator()) {
            val dy = (y - lastY) * -1
            if (dy > 0) repeat(maxX - lastX) { print('.') }
            repeat(dy) { println() }
            if (dy > 0) repeat(x - minX) { print('.') }
            repeat(if (dy <= 0) x - lastX - 1 else 0) { print('.') }
            print('*')
            lastX = x
            lastY = y
        }
        repeat(maxX - lastX) { print('.') }
    }
}
