#include <cstdio>
#include <cstdlib>
#include <cstring>

int x = 0, y = 0, xmin = 0, ymin = 0, xmax = 0, ymax = 0;
char *f;

void Check( void )
{
  if (x > xmax)
    xmax = x;
  else if (x < xmin)
    xmin = x;

  if (y > ymax)
    ymax = y;
  else if (y < ymin)
    ymin = y;
}

void Draw( void )
{
  static int xl = -xmin, yl = ymax;
  int
    xi = x - xl >= 0 ? x != xl ? 1 : 0 : -1,
    yi = y - yl >= 0 ? y != yl ? 1 : 0 : -1;

  for (xl += xi; xl != x; xl += xi)
    f[yl * (xmax - xmin + 1) + xl] = 1;
  f[yl * (xmax - xmin + 1) + xl] = 1;


  for (yl += yi; yl != y; yl += yi)
    f[yl * (xmax - xmin + 1) + xl] = 1;
  f[yl * (xmax - xmin + 1) + xl] = 1;
}

int main( void )
{
  int d, d0, k, n;

  scanf("%i%i%i", &n, &d0, &k);
  d = d0;

  for (int i = 0, r = 0; i < n; i += fabs(d), r = !r)
  {
    if (r)
    {
      y += d;
      d *= -k;
    }
    else
      x += d;
    Check();
  }

  printf("%i %i\n", ymax - ymin + 1, xmax - xmin + 1);

  f = (char *)malloc(sizeof(char) * (ymax - ymin + 1) * (xmax - xmin + 1));
  memset(f, 0, sizeof(char) * (ymax - ymin + 1) * (xmax - xmin + 1));

  x = -xmin, y = ymax, d = d0;

  f[y * (xmax - xmin + 1) + x] = 1;

  for (int i = 0, r = 0; i < n; Draw(), r = !r)
    if (r)
    {
      y += n - i >= fabs(d) ? d : (n - i) * (d / fabs(d));
      i += fabs(d);
      d *= -k;
    }
    else
    {
      x += n - i >= fabs(d) ? d : (n - i) * (d / fabs(d));
      i += fabs(d);
    }

  for (int i = ymax - ymin; i > -1; i--)
    for (int j = 0; j < xmax - xmin + 1; j++)
      printf("%c%s", (f[i * (xmax - xmin + 1) + j] ? '*' : '.'), (j == ymax - ymin ? "\n" : ""));

  return 0;
}