import java.io.*;
import java.util.*;

public class F {

    public void solve() throws IOException {
        int k = nextInt();
        int n = nextInt();
        for (int i = 0; i < n; i++) {
            nextToken();
        }
        int[] cnt1 = new int[k];
        int[] cnt2 = new int[k];
        String s = nextToken();
        String t = nextToken();
        if (s.equals(t)) {
            out.print("YES");
            return;
        }
        for (int i = 0; i < s.length(); i++) {
            cnt1[s.charAt(i) - 'a']++;
            cnt2[t.charAt(i) - 'a']++;
        }
        for (int i = 0; i < k; i++) {
            if (cnt1[i] != cnt2[i]) {
                out.print("NO");
                return;
            }
        }
        if (n > 0) {
            out.print("Yes");
        } else {
            out.print("No");
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new F().run();
    }
}