#include <iostream>
#include <cmath>
#include <cstring>

using namespace std;


class Point
{
public:
  long x, y;

  Point( long X = 0, long Y = 0 ) : x(X), y(Y)
  {
  
  }

  void operator+=( const Point &P )
  {
    x += P.x;
    y += P.y;
  }

  void TurnLeft( void )
  {
    if (x == 1)
      x = 0, y = 1;
    else if (x == -1)
      x = 0, y = -1;
    else if (y == 1)
      x = -1, y = 0;
    else
      x = 1, y = 0;
  }
} Pos, Dir(1, 0);


//static char Path[10000000];

int main( void )
{
  int n, d, k, len = 0, hm = 0, wm = 0, h = 0, w = 0;
  Point Coord[1000];

  cin >> n >> d >> k;


  int l = 1;
  Coord[0] = Point(0, 0);
  for (int i = 0; i < n;)
  {
    int j;
    for (j = 0; j < d && i < n; j++, i++)
    {
      Pos.x += Dir.x;

      Coord[l++] = Pos;
    }

    if (Pos.x > 0 && w < Pos.x)
      w = Pos.x;
    else if(wm > Pos.x)
      wm = Pos.x;

    Dir.TurnLeft();
    for (j = 0; j < d && i < n; j++, i++)
    {
      Pos.y += Dir.y;
      Coord[l++] = Pos;
    }

    if (Pos.y > 0 && h < Pos.y)
      h = Pos.y;
    else if(hm > Pos.y)
      hm = Pos.y;

    Dir.TurnLeft();
    //i += d * 2;
    d *= k;
  }

  int sw = w - wm + 1;
  int sh = h - hm + 1;


  cout << sh << ' ' << sw << '\n';

  char *Field = new char[sw * sh];
  memset(Field, '.', sw * sh);

 
  for (int i = h; i >= hm; i--)
  {
    for (int j = wm; j < w + 1; j++)
    {
      int flag = 0;
      for (int k = 0; k < l; k++)
        if (Coord[k].x == j && Coord[k].y == i)
        {
          flag = 1;
          break;
        }

      if (flag == 1)
        cout << '*';
      else
        cout << '.';
    }
    cout << '\n';
  }
  /*for (int i = 0; i < l; i++)
  {
    Field[Coord[i].y * sw + Coord[i].x] = '*';
  } */
   
  /*for (int i = sh - 1; i >= 0; i--)
  {
    for (int j = 0; j < sw; j++)
        cout << Field[i * sh + j];
    
  } */
 return 0;
}


