#include <cstdio>
#include <iostream>
#include <string>

long long GCD( long long a, long long b )
{
  while (true)
  {
    a %= b;
    if (a == 0)
      return b;
    b %= a;
    if (b == 0)
      return a;
  }
}

int main( void )
{
  int n, k;
  std::cin >> n >> k;
  long long *window = new long long[k];
  for (int i = 0; i < k; i++)
    std::cin >> window[i];
  long long max_gcd = 0;

  int gcd = GCD(window[0], window[k - 1]);
  if (gcd > max_gcd)
    max_gcd = gcd;

  for (int i = k; i < n; i++)
  {
    int gcd = GCD(window[0], window[k - 1]);
    if (gcd > max_gcd)
      max_gcd = gcd;
    memmove(window, window + 1, sizeof(long long) * (k - 1));
    std::cin >> window[k - 1];
  }
  std::cout << max_gcd << std::endl;
  return 0;
}