#include <iostream>

int gcd(int a, int b)
{
    return b ? gcd(b, a % b) : a;
}

int gcd(long long * a, int index, int k)
{
    int max = k + index;
    int res = gcd(a[index], a[index + 1]);
    for (int i = index + 2; i < max; i++)
    {
        res = gcd(res, a[i]);
    }
    return res;
}

int main()
{
    int n, k;
    std::cin >> n >> k;
    long long a[n];
    for (int i = 0; i < n; i++)
    {
        std::cin >> a[i];
    }
    int max = n - k + 1;
    int res = 0;
    int data;
    for (int i = 0; i < max; i++)
    {
        data = gcd(a, i, k);
        if (res < data)
            res = data;
    }
    std::cout << res;
}
