#include <iostream>
#include <algorithm>

using namespace std;

long long gcd(long long a, long long b)
{
    if (a < b) swap(a, b);
    if (b == 0) return a;
    return gcd(b, a%b);
}

int main()
{

    int n, k;
    cin >> n >> k;

    long long a[n], pr[n/k + 1][k], sf[n/k+1][k], res = 1;
    for (int i = 0; i < n; i++) cin >> a[i];

    for (int i = k-1; i < n; i += k)
    {
        int pos = i/k;
        for (int j = 1; j < k; j++) sf[pos][j] = 1;
        pr[pos][0] = a[i];
        if (i+1 < n) sf[pos][0]= a[i+1];

        for (int j = 1; j < k; j++) pr[pos][j] = gcd(pr[pos][j-1], a[i-j]);
        for (int j = 1; j < min(k, n-i-1); j++) sf[pos][j] = gcd(sf[pos][j-1], a[i+j+1]);

        res = max(res, pr[pos][k-1]);
        for (int j = k-2; j >= 0; j--)
            res = max(res, gcd(pr[pos][j], sf[pos][k-j-2]));
    }


    cout << res << "\n";
    return 0;
}
