#include <iostream>
#include <vector>

using namespace std;

typedef long long ll;

ll gcd(ll a, ll b) {
    if (a < b) swap(a, b);
    if (b == 0) return a;
    return gcd(b, a % b);
}

vector<vector<ll> > ans(27);
vector<int> deg2(27);

int main() {
    int n, k;
    n = 1, k = 0;
    while (k < 27) {
        deg2[k] = n;
        n *= 2;
        k++;
    }
    cin >> n >> k;
    for (int i = 0; i < 27; i++) {
        ans[i].resize(n);
    }
    vector<ll> val(n);
    for (int i = 0; i < n; i++) {
        cin >> val[i];
        ans[i][0] = val[i];
    }
    int i = 1;
    while (i < n) {
        for (int j = 0; j + i - 1 < n; j++) {
            ans[j][i] = gcd(ans[j][i / 2], ans[j + i / 2][i / 2]);
            //cout << j << " " << i << " " << ans[j][i] << endl;
        }
        i *= 2;
    }
    ll answ = 1;
    ll cur_ans = 1;
    i = 1;
    while(2 * i < k) i *= 2;
    for (int j = 0; j + k - 1 < n; j++) {
        cur_ans = gcd(ans[j][i], ans[j + k - i][i]);
        answ = max(answ, cur_ans);
    }
    cout << answ << endl;
    return 0;
}
