#include <bits/stdc++.h>
using namespace std;

long long nod(long long a, long long b) {
    if(a > b) {
       swap(a, b);
    }
    while(a > 1 && b > 1) {
        if(a > b) {
           swap(a, b);
        }
        long long c = a;
        a = b % a;
        b = c;
    }
    if(a == 1)
        return 1;
    return b;
}

struct tree {
    vector<long long> el;
    long long n;
    tree(vector<long long> a) {
        long long k = 1;
        while(k < a.size()) {
            k *= 2;
        }
        el.resize(k * 2);
        n = k;
        for(long long i = n; i < n + a.size(); i++) {
            el[i] = a[i - n];
        }
    }
    tree() {}
    long long build(long long v) {
        if(v < n) {
            el[v] = nod(build(v * 2), build(v * 2 + 1));
        }
        return el[v];
    }
    long long get(long long l, long long r, long long cl, long long cr, long long v) {
        if(cl >= l && cr <= r) {
            return el[v];
        }
        if(cl >= r || cr <= l) {
            return 0;
        }
        long long m = (cl + cr) / 2;
        return nod(get(l, r, cl, m, v * 2), get(l, r, m, cr, v * 2 + 1));
    }
};
int main() {
    long long n, k;
    cin >> n >> k;
    vector<long long> a(n);
    for(long long i = 0; i < n; i++) {
        cin >> a[i];
    }
    auto x = tree(a);
    x.build(1);
    long long ma = 1;
    for(long long i = 0; i + k <= n; i++) {
        ma = max(ma, x.get(i, i + k, 0, x.n, 1));
    }
    cout << ma;
    return 0;
}
/*
10 4
2 3 4 8 12 6 12 18 4 3
 */