#include <iostream>
#include <set>

using namespace std;

bool com[20][20];
set <int> poses[20];

int main() {
    int k, n;
    cin >> k >> n;
    for (int i = 0; i < 20; i++) {
        for (int j = 0; j < 20; j++) {
            com[i][j] = 0;
        }
    }
    for (int i = 0; i < k; i++) com[i][i] = 1;
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        int a = s[0] - 'a', b = s[1] - 'a';
        com[a][b] = com[b][a] = 1;
    }
    string s, t;
    cin >> s >> t;
    for (int i = 0; i < s.length(); i++) {
        poses[s[i] - 'a'].insert(i);
    }
    for (int i = 0; i < s.length(); i++) {
        if (poses[t[i] - 'a'].empty()) {
            cout << "NO" << endl;
            return 0;
        }
        int r = *poses[t[i] - 'a'].begin();
        poses[t[i] - 'a'].erase(r);
        for (int j = 0; j < k; j++) {
            if (poses[j].empty()) continue;
            int f = *poses[j].begin();
            if (f <= r && !com[t[i] - 'a'][j]) {
                cout << "NO" << endl;
                return 0;
            }
        }
    }
    cout << "YES" << endl;
    return 0;
}
