#include <bits/stdc++.h>

using namespace std;
using nagai = long long;

int p[26];
int getp(int x)
{
	return x == p[x] ? x : p[x] = getp(p[x]);
}
void unite(int a, int b)
{
	p[getp(a)] = getp(b);
}
int main()
{
	int k, n;
	cin >> k >> n;
	iota(p, p + k, 0);
	for (int i = 0; i < n; ++i)
	{
		string s;
		cin >> s;
		unite(s[0] - 'a', s[1] - 'a');
	}
	string s, t;
	cin >> s >> t;
	n = s.size();
	bool ok = true;
	for (int i = 0; i < n; ++i)
	{
		if (getp(s[i] - 'a') != getp(t[i] - 'a'))
			ok = false;
	}
	vector<int> cur(26);
	for (int i = 0; i < n; ++i)
	{
		++cur[s[i] - 'a'];
		--cur[t[i] - 'a'];
		if (i == n - 1 || getp(s[i] - 'a') != getp(s[i + 1] - 'a'))
		{
			if (count(cur.begin(), cur.end(), 0) != cur.size())
				ok = false;
			fill(cur.begin(), cur.end(), 0);
		}
	}
	if (ok)
		cout << "YES\n";
	else
		cout << "NO\n";
}