#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

long long gcd_single(long long a, long long b)
{
    if (a > 0) {
        return gcd_single(b % a, a);
    }
    else {
        return b;
    }
}

long long gcd(vector<long long> mas)
{
    if (mas.size() == 1) {
        return mas[0];
    }
    mas[1] = gcd_single(mas[0], mas[1]);
    mas.erase(mas.begin());
    return gcd(mas);
}

int main()
{
    int n, k;
    cin >> n >> k;
    vector<long long> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    vector<long long> mas;
    for (int i = 0; i < k; i++) {
        mas.push_back(a[i]);
    }
    long long max_gcd = 0;
    max_gcd = max(max_gcd, gcd(mas));
    for (int i = k; i < n; i++) {
        mas.erase(mas.begin());
        mas.push_back(a[i]);
        max_gcd = max(max_gcd, gcd(mas));
    }
    cout << max_gcd;
    return 0;
}
