#include <iostream>
#include<bits/stdc++.h>

#define pb push_back
#define mp make_pair
#define fi first
#define se second

using namespace std;
typedef long long ll;
typedef long double ld;
const int INF = 1e6;
const int NUM = 5e5 + 5;
ll t[4 * NUM];
ll a[NUM];

ll gcd(ll a, ll b){
    if (b == 0)
        return a;
    return gcd(b, a % b);
}

void build(int v, int l, int r){
    if (r - l == 1){
        t[v] = a[l];
        return;
    }
    int m = (l + r) / 2;
    build(2 * v, l, m);
    build(2 * v + 1, m, r);
    t[v] = gcd(t[2 * v], t[2 * v + 1]);
}

ll get(int v, int tl, int tr, int l, int r){
    if (tl == l && tr == r)
        return t[v];
    int m = (tl + tr) / 2;
    if (r <= m)
        return get(2 * v, tl, m, l, r);
    if (l >= m)
        return get(2 * v + 1, m, tr, l, r);
    return gcd(get(2 * v, tl, m, l, m), get(2 * v + 1, m, tr, m, r));
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, k;
    cin >> n >> k;
    for (int i = 0; i < n; i++)
        cin >> a[i];
    build(1, 0, n);
    ll ans = 0;
    for (int i = 0; i <= n - k; i++)
        ans = max(ans, get(1, 0, n, i, i + k));
    cout << ans;
    return 0;
}
