#include <iostream>
#include<bits/stdc++.h>

#define pb push_back
#define mp make_pair
#define fi first
#define se second

using namespace std;
typedef long long ll;
typedef long double ld;
const int INF = 1e6;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int k, n;
    cin >> k >> n;
    bool g[k][k];
    for (int i = 0; i < k; i++)
        for (int j = 0; j < k; j++)
            g[i][j] = false;
    for (int i = 0; i < n; i++){
        string link;
        cin >> link;
        int v = link[0] - 'a', u = link[1] - 'a';
        g[v][u] = g[u][v] = true;
    }
    string s, t;
    cin >> s >> t;
    n = s.length();
    int cnt[n][k];
    for (int i = 0; i < k; i++){
        if (s[0] == 'a' + i)
            cnt[0][i] = 1;
        else
            cnt[0][i] = 0;
        g[i][i] = true;
    }
    vector<int> pos[k];
    for (int i = 1; i < n; i++)
        for (int j = 0; j < k; j++){
            cnt[i][j] = cnt[i - 1][j];
            if (s[i] - 'a' == j)
                cnt[i][j]++;
        }
    //cout << cnt[3][2] << endl;
    for (int i = 0; i < n; i++)
        pos[s[i] - 'a'].pb(i);

    int border[k], num[k];
    for (int j = 0; j < k; j++){
        border[j] = 0;
        num[j] = 0;
    }
    for (int i = 0; i < n; i++){
        int c = t[i] - 'a';
        if (pos[c].size() == 0){
            cout << "NO";
            return 0;
        }
        vector<int> :: iterator it = lower_bound(pos[c].begin(), pos[c].end(), border[c]);
        if (it == pos[c].end()){
            cout << "NO";
            return 0;
        }
        int p = *it;
        border[c] = p + 1;
        for (int j = 0; j < k; j++)
            if (p && cnt[p - 1][j] > num[j] && !g[c][j]){
                cout << "NO";
                return 0;
            }
            num[c]++;
    }
    cout << "YES";
    return 0;
}
