#include <iostream>
#include <set>
#include <algorithm>
#include <queue>
#include <vector>
using namespace std;

#define ll long long
#define vii vector<int>
#define pii pair<int, int>
#define ld long double
#define s second
#define f first
#define mp make_pair

ll gcd(ll a, ll b)
{
    if(b == 0)
        return a;
    else
        return gcd(b, a % b);
}

int main()
{
    ll n, k;
    cin >> n >> k;
    vector<ll> a(n);
    for(int i = 0; i < n; i++)
        cin >> a[i];

    vector<vector<ll> > dp(n, vector<ll>(2));

    for(int i = 0; i < n; i++)
        dp[i][1] = a[i];

    int cur = 1;
    for(ll len = 2; len <= k; len++)
    {
        cur++;
        cur %= 2;
        for(ll x = 0; x <= n - k; x++)
        {
            if(cur == 0)
                dp[x][0] = gcd(dp[x][1], a[x + len - 1]);
            else
                dp[x][1] = gcd(dp[x][0], a[x + len - 1]);
        }
    }
    ll answ = 0;
    for(int i = 0; i <= n - k; i++)
        answ = max(answ, dp[i][cur]);
    cout << answ << endl;
    return 0;
}
