#include <iostream>
#include <vector>
#include <algorithm>
#include <utility>

using namespace std;

int main() {
    int n, d, k; cin >> n >> d >> k;

    vector<pair<int, int>> points;
    points.reserve(1001);
    int maxr = 0, maxu = 0, maxl = 0, maxd = 0;

    {
        pair<int, int> coord{0, 0};
        int r = 0;
        int s = 0;
        int p = 0;
        int l = d;
        bool f = false;

        while(s < n) {
            if(p == l) {
                if(f) l *= k;
                f = !f;
                r = (r+1)%4;
                p = 0;
            }
            switch(r) {
                case 0: coord.first++; break;
                case 1: coord.second++; break;
                case 2: coord.first--; break;
                case 3: coord.second--;
            }

            points.push_back(coord);

            if(coord.first >= 0) maxr = max(maxr, coord.first); else maxl = min(maxl, coord.first);
            if(coord.second >= 0) maxu = max(maxu, coord.second); else maxd = min(maxd, coord.second);

            s++;
            p++;
        }
    }

    cout << maxu-maxd+1 << " " << maxr-maxl+1 << "\n";

    std::sort(points.begin(), points.end());

    for(int y = maxu; y >= maxd; y--) {
        for(int x = maxl; x <= maxr; x++) 
            if(binary_search(points.begin(), points.end(), pair<int, int>{x, y}) || (x==0&y==0))
                cout << "*";
            else 
                cout << ".";
        cout << "\n";
    }

}