﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ConsoleApplication3
{
    class Program
    {

        static void Main(string[] args)
        {
            int h = 5000;
            int w = 5000;
            char[,] map = new char[w, h];

            int x = 2500;
            int y = 2500;

            int minx = x;
            int maxx = x;
            int miny = y;
            int maxy = y;

            string[] input = Console.ReadLine().Split(' ');

            int n = Int32.Parse(input[0]);
            int stepsForward = Int32.Parse(input[1]);
            int k = Int32.Parse(input[2]);
            int vector = 0;

            for (int i = 0; i < w; i++)
            {
                for(int j = 0; j < h; j++)
                {
                    map[i, j] = '.';
                }
            }

                while (n >= 0)
                {
                    for (int j = 0; j < 2; j++)
                    {
                        for (int i = 0; i < stepsForward; i++)
                        {

                            //skip
                            if (n < 0)
                                continue;

                            if (x < minx) { minx = x; }
                            if (x > maxx) { maxx = x; }
                            if (y < miny) { miny = y; }
                            if (y > maxy) { maxy = y; }

                            //draw
                            map[x, y] = '*';

                            if (vector == 0)
                            {
                                x++;
                            }
                            else if (vector == 1)
                            {
                                y--;
                            }
                            else if (vector == 2)
                            {
                                x--;
                            }
                            else
                            {
                                y++;
                            }


                            n--;
                        }
                        vector = (vector + 1) % 4;
                    }



                    stepsForward = stepsForward * k;
                }


                Console.WriteLine(Convert.ToString(maxy - miny + 1) + " " + Convert.ToString(maxx - minx + 1));    

                for (int i = miny; i <= maxy; i++)
                {
                    for (int j = minx; j <= maxx; j++)
                    {
                        Console.Write(map[j, i]);
                    }
                    Console.WriteLine();
                }

            Console.Read();
        }
    }
}
