#include <string>
#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int k, n;
	cin >> k >> n;
	vector <vector <char> > pairs(k);

	for (int i = 0; i < n; i++)
	{
		string inp;
		cin >> inp;
		pairs[inp[0] - 'a'].push_back(inp[1]);
		pairs[inp[1] - 'a'].push_back(inp[0]);
	}

	string s1, s2;
	cin >> s1 >> s2;
	bool flag = true;

	while (flag && !s1.empty())
	{
		if (s1[0] == s2[0])
		{
			s1.erase(s1.begin());
			s2.erase(s2.begin());
			continue;
		}
		else
		{
			char c = s2[0];
			int f = s1.find(c);
			if (f < 0)
			{
				flag = false;
			}
			else
			{
				if (find(pairs[s1[f] - 'a'].begin(), pairs[s1[f] - 'a'].end(), s1[f - 1]) != pairs[s1[f] - 'a'].end())
				{
					swap(s1[f], s1[f - 1]);
				}
				else
				{
					flag = false;
				}
			}
		}
	}

	if (flag)
	{
		cout << "YES";
	}
	else
	{
		cout << "NO";
	}

	system("pause");
	return 0;
}