﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Спираль
{
    class Program
    {
        static int currentXDirection = 1;
        static int currentYDirection = 0;
        static void Main(string[] args)
        {
            string[] input = Console.ReadLine().Split(' ');
            int n = Convert.ToInt32(input[0]);
            int d = Convert.ToInt32(input[1]);
            int k = Convert.ToInt32(input[2]);
            List<int> xs = new List<int>();
            List<int> ys = new List<int>();
            xs.Add(0);
            ys.Add(0);
            int currentX = 0;
            int currentY = 0;
            int s = 0;
            int canMove = d;
            bool canMovePereschitan = false;
            while (s < n)
            {
                if (canMove > 0)
                {
                    currentX += currentXDirection;
                    currentY += currentYDirection;
                    xs.Add(currentX);
                    ys.Add(currentY);
                    s++;
                    canMove--;
                }
                else
                {
                    ChangeDirection();
                    if (canMovePereschitan)
                    {
                        canMovePereschitan = false;
                        d *= k;
                        canMove = d;
                    }
                    else
                    {
                        canMove = d;
                        canMovePereschitan = true;
                    }
                }
            }
            int minX = xs.Min();
            int maxX = xs.Max();
            int minY = ys.Min();
            int maxY = ys.Max();
            int w = maxX - minX + 1;
            int h = maxY - minY + 1;
            int[,]table=new int[w,h];
            for(int i=0;i<xs.Count;i++)
            {
                table[xs[i] - minX, maxY - ys[i]] = 1;
            }

            List<string> output = new List<string>();
            for (int hi = 0; hi < h; hi++)
            {
                string newS = "";
                for (int wi = 0; wi < w; wi++)
                {
                    if (table[wi, hi] == 0)
                        newS += ".";
                    else
                        newS += "*";
                }
                output.Add(newS);
            }
            Console.WriteLine(h + " " + w);
            foreach (string st in output)
                Console.WriteLine(st);
        }
        static void ChangeDirection()
        {
            if (currentXDirection == 1 && currentYDirection == 0)
            {
                currentXDirection = 0;
                currentYDirection = 1;
                return;
            }
            if (currentXDirection == 0 && currentYDirection == 1)
            {
                currentXDirection = -1;
                currentYDirection = 0;
                return;
            }
            if (currentXDirection == -1 && currentYDirection == 0)
            {
                currentXDirection = 0;
                currentYDirection = -1;
                return;
            }
            if (currentXDirection == 0 && currentYDirection == -1)
            {
                currentXDirection = 1;
                currentYDirection = 0;
                return;
            }
        }
    }
}
