#include <iostream>
#include <vector>
#include <cmath>

#define fi first
#define se second

typedef long long LL;
typedef long double LD;

//#define DEBUG
#ifdef DEBUG
#include "debug.h"
#endif

using namespace std;

int n, t, k = 0;

vector<int> a;
vector<int> used;

void f(int p) {
	if(k == t) return;
	if(p < n){
		for (int i = 1; i <= n; i++){
			if(i == p + 1 || used[i]) continue;
			a[p] = i;
			used[i] = 1;
			f(p + 1);
			if(k == t) return;
			used[i] = 0;
		}
	} else {
		for (int i = 0; i < n; i++) {
			cout << a[i] << ' ' ;
		}
		cout << endl;
		k++;
		if(k == t) return;
	}
}

int main(){
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	cin >> n >> t;
	a.resize(n);
	used.resize(n+1);
	f(0);
	return 0;
}