#include <bits/stdc++.h>

using namespace std;

vector<long long> a;
long long *st;
long long gcd(long long a, long long b) {
	if(a > b)
		swap(a, b);
	while(b) {
		a %= b;
		swap(a, b);
	}
	return a;
}

long long max(long long a, long long b) {
	if(a > b)
		return a;
	return b;
}

long long findGcd(int ss, int se, int qs, int qe, int si) {
	if(ss > qe || se < qs)
		return 0;
	if(qs <= ss && qe >= se)
		return st[si];
	int mid = ss + (se - ss) / 2;
	return gcd(findGcd(ss, mid, qs, qe, si * 2 + 1),
			   findGcd(mid + 1, se, qs, qe, si * 2 + 2));
}

long long findRangeGcd(int ss, int se, vector<long long> arr, int n) {
	return findGcd(0, n - 1, ss, se, 0);
}

long long constructST(vector<long long> arr, int ss, int se, int si) {
	if(ss == se) {
		st[si] = arr[ss];
		return st[si];
	}
	int mid = ss + (se - ss) / 2;
	st[si] = gcd(constructST(arr, ss, mid, si * 2 + 1),
				 constructST(arr, mid + 1, se, si * 2 + 2));
	return st[si];
}

long long *constructSegmentTree(vector<long long> arr, int n) {
	int height = (int) (ceil(log2(n)));
	int size = 2 * (int) pow(2, height) - 1;
	st = new long long[size];
	constructST(arr, 0, n - 1, 0);
	return st;
}

int main() {
	int n, k;
	cin >> n >> k;
	a.resize(n);
	for(int i = 0; i < n; i++)
		cin >> a[i];
	constructSegmentTree(a, n);

	int out = LONG_LONG_MIN;
	for(int i = 0; i < n - k; i++)
		out = max(out, findRangeGcd(i, i + k - 1, a, n));
	cout << out << endl;

	return 0;
}

