n, d, k = map(int, input().split())
x, y = 0, 0
direction = (1, 0)
coloured = set()
def rotate(direction):
    return (direction[1], -direction[0])
def colour(x, y, d, direction):
    x0, y0 = x, y
    while (x, y) != (x0 + direction[0] * d, y0 + direction[1] * d):
        coloured.add((x, y))
        x += direction[0]
        y += direction[1]
    coloured.add((x, y))
def maketable(coloured):
    minx, miny, maxx, maxy = float('inf'), float('inf'), float('-inf'), float('-inf')
    for i in coloured:
        if i[0] < minx:
            minx = i[0]
        if i[1] < miny:
            miny = i[1]
        if i[0] > maxx:
            maxx = i[0]
        if i[1] > maxy:
            maxy = i[1]
    for i in range(len(coloured)):
        coloured[i] = (coloured[i][0] - minx, coloured[i][1] - miny)
    m, n = maxx - minx + 1, maxy - miny + 1
    table = [['.' for _ in range(m)] for __ in range(n)]
    for x, y in coloured:
        table[y][x] = '*'
    for i in range(n):
        table[i] = ''.join(table[i])
    return table
while n > 0:
    if n < d:
        colour(x, y, n, direction)
        break
    elif n < 2 * d:
        colour(x, y, d, direction)
        x += direction[0] * d
        y += direction[1] * d
        direction = rotate(direction)
        colour(x, y, n - d, direction)
        break
    else:
        colour(x, y, d, direction)
        x += direction[0] * d
        y += direction[1] * d
        direction = rotate(direction)
        colour(x, y, d, direction)
        x += direction[0] * d
        y += direction[1] * d
        n -= 2 * d
        d *= k

        direction = rotate(direction)
coloured = sorted(list(coloured))
table = maketable(coloured)
print(*table, sep='\n')