import java.util.Scanner;

public class E {
	public static long euclid(long a, long b) {

		if (a > b) {
			a = a - b;
			b = euclid(a, b);
		} else {
			if (a < b) {
				b = b - a;
				a = euclid(a, b);
			}
		}
		if (a == b) {
			return a;
		}
		if (a == 1 || b == 1) {
			return 1;
		}
		return a;

	}

	public static void main(String[] args) {
		Scanner sc = new Scanner(System.in);
		int n = sc.nextInt();
		int k = sc.nextInt();
		long arr[] = new long[n];
		long A[][] = new long[k + 1][n];
		for (int i = 0; i < n; i++) {
			arr[i] = sc.nextLong();

		}
		for (int i = 0; i < n; i++) {
			A[1][i] = arr[i];
		}
		for (int x = 2; x <= k; x++) {
			for (int i = x - 1; i < n; i++) {
				A[x][i] = euclid(A[x - 1][i - 1], arr[i]);
			}
		}
		long maxnum = 0;
		for (int i = k - 1; i < n; i++) {
			if (A[k][i] > maxnum) {
				maxnum = A[k][i];
			}
		}
		System.out.println(maxnum);

	}
}
