import java.util.Scanner;

public class E1 {
    static long a[];

    private static long gcd(long a, long b) {
        long c = Math.max(a, b);
        long d = Math.min(a, b);
        while (c != 0 && d != 0) {
            c %= d;
            long t = d;
            d = c;
            c = t;
        }
        return c + d;
    }

    static class Sl {
        int l, r;
        long value;
        Sl left, right;

        public long build(Sl t, int l, int r) {
            t.l = l;
            t.r = r;
            if (l == r) {
                t.value = a[l];
                return a[l];
            }
            Sl tl = new Sl();
            Sl tr = new Sl();
            t.left = tl;
            t.right = tr;
            t.value = gcd(build(tl, l, (l + r) / 2), build(tr, 1 + (l + r) / 2, r));
            return t.value;
        }

        public long count(int l, int r) {
            if (this.l == l && this.r == r) {
                return this.value;
            }
            int mid = (this.l + this.r) / 2;
            if (r <= mid) {
                return this.left.count(l, r);
            } else if (l > mid) {
                return this.right.count(l, r);
            } else {
                return gcd(this.left.count(l, mid), this.right.count(mid + 1, r));
            }
        }
    }

    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        int n = sc.nextInt();
        int k = sc.nextInt();
        a = new long[n];
        for (int i = 0; i < n; i++) {
            a[i] = sc.nextInt();
        }
        Sl nd = new Sl();
        nd.build(nd, 0, n - 1);
        long maxNd = 0;
        for (int i = 0; i <= n - k; i++) {
            maxNd = Math.max(maxNd, nd.count(i, i + k - 1));
        }
        System.out.println(maxNd);

    }
}
