import java.util.PriorityQueue;
import java.util.Scanner;

public class TaskE {

	public static void main(String[] args) {
		Scanner sc = new Scanner(System.in);
		int n = sc.nextInt();
		int k = sc.nextInt();
		long[] arr = new long[n];
		for (int i = 0; i < n; i++) {
			arr[i] = sc.nextLong();
		}
		sc.close();
		PriorityQueue<Long> pq = new PriorityQueue<Long>();
		for (int i = 0; i < k; i++) {
			pq.add(arr[i]);
		}
		long amin = 1;
		long maxans = 1;
		for (int i = k; i <= n; i++) {
			amin = pq.poll();
			for (int j = 1; j <= amin; j++) {
				boolean flag = true;
				for (int l = i - k; l < i; l++) {
					if (arr[l] % j != 0) {
						flag = false;
						break;
					}
				}
				if (flag) {
					maxans = Math.max(maxans, j);
				}
			}
			if (i == n)
				break;
			pq.add(arr[i]);
		}

		System.out.println(maxans);

	}

}
