#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
using namespace std;

void out() {
	cout << "NO\n";
	exit(0);
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int k, n; cin >> k >> n;
	vector<vector<bool>> can(k, vector<bool>(k));
	vector<bool> was(k);
	for (int i = 0; i < n; i++) {
		char a, b; cin >> a >> b;
		can[a - 'a'][b - 'a'] = true;
		can[b - 'a'][a - 'a'] = true;
		was[a - 'a'] = was[b - 'a'] = true;
	}
	string a, b;
	cin >> a >> b;
	n = a.size();
	vector<pair<int, int>> need;
	for (int i = 0; i < n; i++) {
		if (!was[a[i] - 'a'] || !was[b[i] - 'a']) {
			if (a[i] != b[i])
				out();
			continue;
		}
		int j = i;
		for (; j < n; j++) {
			if (!was[a[j] - 'a'] || !was[b[j] - 'a']) {
				if (a[j] != b[j])
					out();
				break;
			}
		}
		need.emplace_back(i, j - 1);
		i = j;
	}
	for (auto &p : need) {
		string s = "";
		string t = "";
		for (int i = p.first; i <= p.second; i++) {
			s.push_back(a[i]);
			t.push_back(b[i]);
		}
		int n = s.size();
		for (int i = 0; i < n; i++) {
			if (s[i] == t[i])
				continue;
			int j = i;
			for (; j < n; j++) {
				if (s[j] == t[i]) {
					break;
				}
			}
			if (j == n) {
				out();
			}
			for (int k = j - 1; k >= i; k--) {
				if (!can[s[k] - 'a'][s[k + 1] - 'a']) {
					out();
				}
				swap(s[k], s[k + 1]);
			}
		}
	}
	cout << "YES\n";
	//system("pause");
}