#include <cstdio>
#include <cstdlib>

char *s, *t, *pairs;
int k, n;

int pair( char a, char b )
{
  for (int i = 0; i < n; i++)
    if (pairs[i * 2] == a && pairs[i * 2 + 1] == b || pairs[i * 2 + 1] == a && pairs[i * 2] == b)
      return 0;
  return 1;
}

int find( int i )
{
  int j;

  for (j = i; j < k; j++)
    if (pair(s[j], t[i]))
      if (s[j] == t[i])
        break;
      else
        return 1;

  if (j == k)
    return 1;

  char r = s[j - 1];
  for (int l = j - 1; l > i; l--)
    s[l] = s[l - 1];
  s[i] = s[j];
  s[j] = r;
  return 0;
}

int main( void )
{
  scanf("%i%i", &k, &n);

  pairs = (char *)malloc(sizeof(char) * 2 * n + 1);
  for (int i = 0; i < n; i++)
    scanf("%s", &pairs[i * 2]);


  s = (char *)malloc(sizeof(char) * 10);
  t = (char *)malloc(sizeof(char) * 10);
  scanf("%s\n", s);
  scanf("%s", t);
  k = 0;
  while (s[k] != 0)
    k++;

  for (int i = 0; i < k; i++)
    if (s[i] != t[i])
      if (find(i))
      {
        printf("NO");
        return 0;
      }

  printf("YES");

  return 0;
}