import java.io.*;
import java.util.*;

public class D {

    public int[] a;
    public int cnt = 0;
    public int n, t;
    public boolean[] used;


    public void gen(int pos) {
        if (cnt == t)
            return;
        if (pos == n + 1) {
            for (int i = 1; i <= n; i++) {
                out.print(a[i]);
                out.print(' ');
            }
            cnt++;
            out.println();
        } else {
            for (int val = 1; val <= n; val++) {
                if (used[val] || val == pos) {
                    continue;
                }
                a[pos] = val;
                used[val] = true;
                gen(pos + 1);
                used[val] = false;
            }
        }
    }

    public void solve() throws IOException {
        n = nextInt();
        t = nextInt();
        a = new int[n + 1];
        used = new boolean[n + 1];
        gen(1);
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new D().run();
    }
}