directions = [[1, 0], [0, 1], [-1, 0], [0, -1]]
directions_draw  = [[1, 0], [0, -1], [-1, 0], [0, 1]]


def get_pos(action, n, cur_dir, pos, d, k):
  if action == n:
    return pos, d, action, cur_dir

  dir = directions[cur_dir % 4]
  for i in range(d):
    pos[0] += dir[0]
    pos[1] += dir[1]
    action += 1
    if action == n:
      return pos, d, action, cur_dir
  cur_dir += 1
  dir = directions[cur_dir % 4]
  for i in range(d):
    pos[0] += dir[0]
    pos[1] += dir[1]
    action += 1       
    if action == n:
      return pos, d, action
  cur_dir += 1
  dir = directions[cur_dir % 4]
  d *= k

  return pos, d, action, cur_dir


def draw_pos(action, n, cur_dir, pos, d, k):
  if action == n:
    return pos, d, action, cur_dir

  dir = directions[cur_dir % 4]
  for i in range(d):
    pos[0] += dir[0]
    pos[1] += dir[1]
    matrix[pos[1]][pos[0]] = "*"
    action += 1
    if action == n:
      return pos, d, action, cur_dir
  cur_dir += 1
  dir = directions_draw[cur_dir % 4]
  for i in range(d):
    pos[0] += dir[0]
    pos[1] += dir[1]
    action += 1                 
    matrix[pos[1]][pos[0]] = "*"
    if action == n:
      return pos, d, action
  cur_dir += 1
  dir = directions_draw[cur_dir % 4]
  d *= k

  return pos, d, action, cur_dir


n, d, k = [int(x) for x in input().split()]
tmp_d = d
max_left = 0
min_right = 0
max_top = 0
min_bottom = 0

pos = [0, 0]
cur_dir = 0
action = 0
while action < n:
  pos, d, action, cur_dir = get_pos(action, n, cur_dir, pos, d, k)
  if pos[0] > max_left:
    max_left = pos[0]
  if pos[0] < min_right:
    min_right = pos[0]
  if pos[1] > max_top:
    max_top = pos[1]
  if pos[1] < min_bottom:
    min_bottom = pos[1]

w = max_left - min_right + 1
h = max_top - min_bottom + 1
print(w, h)
matrix = []
for i in range(h):
  matrix.append(["."] * w)
action = 0
cur_dir = 0
d = tmp_d
pos = [w // 2, h // 2]

while action < n:
  pos, d, action, cur_dir = draw_pos(action, n, cur_dir, pos, d, k)

for i in range(h):
  for j in range(w):
    print(matrix[i][j], end=" ")
  print("\n")

