#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>

using namespace std;

using ll = long long;

int main()
{
  const size_t sz = 4005;
  ll n, d, k;
  cin >> n >> d >> k;
  vector<vector<short>> f(sz, vector<short>(sz, 0));

  ll x = sz / 2, y = sz / 2;
  ll minx = x, miny = y, maxx = x, maxy = y;
  f[x][y] = 2;

  int side = 2;
  int more = 1;
  int bf = 3;
  while (n > 0)
  {
    more--;
    if (more == 0)
    {
      if (--bf == 0)
      {
        d *= k;
        bf = 2;
        //cout << "now " << d << endl;
      }
      more = min(d, n);
      side = (side + 1) % 4;
      //cout << "go k=" << more << endl;
    }
    switch(side) {
    case 0:
      x--;
      break;
    case 1:
      y--;
      break;
    case 2:
      x++;
      break;
    case 3:
      y++;
      break;
    }

    f[x][y] = 1;
    //cout << (x - sz / 2) << " " << y - sz / 2 << endl;
    minx = min(x, minx);
    miny = min(y, miny);
    maxx = max(x, maxx);
    maxy = max(y, maxy);
    n--;
  }

  cout << (maxx - minx + 1) << " " << (maxy - miny + 1) << endl;
  for (ll i = minx; i <= maxx; ++i)
  {
    for (ll j = miny; j <= maxy; ++j)
      cout << (f[i][j] ? '*' : '.');
    cout << endl;
  }

  //system("pause>nul");
  return 0;
}