#include <cstdio>
#include <iostream>
#include <string>
#include <functional>

int main( void )
{
  int k, n;
  std::cin >> k >> n;
  bool mat[10][10] {};
  for (int i = 0; i < n; i++)
  {
    char a, b;
    std::cin >> a >> b;
    mat[a - 'a'][b - 'a'] = mat[b - 'a'][a - 'a'] = true;
  }

  std::string s, t;
  s.reserve(100000);
  t.reserve(100000);
  std::cin >> s >> t;

  auto exists_path = [&]( const std::string &cur_string, int pos1, int pos2 ) -> bool
  {
    int dir = (pos1 > pos2 ? -1 : 1);
    for (int i = pos1; i != pos2; i += dir)
      if (!mat[cur_string[pos1] - 'a'][cur_string[i + dir] - 'a'])
        return false;
    return true;
  };

  std::function<bool ( const std::string &, size_t )> rec = [&]( const std::string &cur_string, size_t pos ) -> bool
  {
    for (; pos < cur_string.size() && cur_string[pos] == t[pos]; pos++)
      ;
    if (pos == cur_string.size())
      return true;

    for (size_t i = pos; i < t.size(); i++)
      if (cur_string[i] == t[pos] && exists_path(cur_string, i, pos))
      {
        std::string a(cur_string);
        memmove((char *)a.data() + pos + 1, (char *)a.data() + pos, i - pos);
        if (rec(a, pos + 1))
          return true;
      }
    return false;
  };

  if (rec(s, 0))
    std::cout << "YES" << std::endl;
  else
    std::cout << "NO" << std::endl;

  return 0;
}